config/routes.rb
Rails.application.routes.draw do

  root 'index#index'

  devise_for :users, controllers: { sessions: 'users/sessions', omniauth_callbacks: 'omniauth_callbacks' }
  
  devise_for :admin, controllers: { sessions: 'admin/sessions' }
  
  devise_for :scores
  
  get 'admin/index'
  
  get 'users/scores'
  
  match 'scores/copy/:id' => 'scores#copy', via: [:post], :as => :copy
  
  match '/users/:id/finish_signup' => 'users#finish_signup', via: [:get, :patch], :as => :finish_signup
  
  resources :users do
    member do
      get :download_score
    end
  end
  
  resources :scores do
    member do
      put :convert
      put :unshare
      put :share
    end
  end
  

end

app/models/user.rb
class User < ApplicationRecord
  TEMP_EMAIL_PREFIX = 'change@me'
  TEMP_EMAIL_REGEX = /\Achange@me/
  
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable, :omniauthable
         
  has_many :scores, dependent: :destroy
  
  validates_format_of :email, :without => TEMP_EMAIL_REGEX, on: :update
  
  def self.find_for_oauth(auth, signed_in_resource = nil)

    # Get the identity and user if they exist
    identity = Identity.find_for_oauth(auth)

    # If a signed_in_resource is provided it always overrides the existing user
    # to prevent the identity being locked with accidentally created accounts.
    # Note that this may leave zombie accounts (with no associated identity) which
    # can be cleaned up at a later date.
    user = signed_in_resource ? signed_in_resource : identity.user

    # Create the user if needed
    if user.nil?

      # Get the existing user by email if the provider gives us a verified email.
      # If no verified email was provided we assign a temporary email and ask the
      # user to verify it on the next step via UsersController.finish_signup
      
      if auth.provider == 'google_oauth2' || 'facebook'
        email = auth.info.email
      else
        email_is_verified = auth.info.email && (auth.info.verified || auth.info.verified_email)
        email = auth.info.email if email_is_verified
      end
      user = User.where(:email => email).first if email

      # Create the user if it's a new registration
      if user.nil?
        user = User.new(
          name: auth.extra.raw_info.name,
          first_name: auth.info.first_name,
          #username: auth.info.nickname || auth.uid,
          email: email ? email : "#{TEMP_EMAIL_PREFIX}-#{auth.uid}-#{auth.provider}.com",
          password: Devise.friendly_token[0,20]
        )
       # user.skip_confirmation!
        user.save!
      end
    end

    # Associate the identity with the user if needed
    if identity.user != user
      identity.user = user
      identity.save!
    end
    user
  end

  def email_verified?
    self.email && self.email !~ TEMP_EMAIL_REGEX
  end
end

app/controllers/users/confirmations_controller.rb
class Users::ConfirmationsController < Devise::ConfirmationsController
  # GET /resource/confirmation/new
  # def new
  #   super
  # end

  # POST /resource/confirmation
  # def create
  #   super
  # end

  # GET /resource/confirmation?confirmation_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after resending confirmation instructions.
  # def after_resending_confirmation_instructions_path_for(resource_name)
  #   super(resource_name)
  # end

  # The path used after confirmation.
  # def after_confirmation_path_for(resource_name, resource)
  #   super(resource_name, resource)
  # end
end

app/controllers/users/omniauth_callbacks_controller.rb
class Users::OmniauthCallbacksController < Devise::OmniauthCallbacksController
  # You should configure your model like this:
  # devise :omniauthable, omniauth_providers: [:twitter]

  # You should also create an action method in this controller like this:
  # def twitter
  # end

  # More info at:
  # https://github.com/plataformatec/devise#omniauth

  # GET|POST /resource/auth/twitter
  # def passthru
  #   super
  # end

  # GET|POST /users/auth/twitter/callback
  # def failure
  #   super
  # end

  # protected

  # The path used when OmniAuth fails
  # def after_omniauth_failure_path_for(scope)
  #   super(scope)
  # end
end

app/controllers/users/passwords_controller.rb
class Users::PasswordsController < Devise::PasswordsController
  # GET /resource/password/new
  # def new
  #   super
  # end

  # POST /resource/password
  # def create
  #   super
  # end

  # GET /resource/password/edit?reset_password_token=abcdef
  # def edit
  #   super
  # end

  # PUT /resource/password
  # def update
  #   super
  # end

  # protected

  # def after_resetting_password_path_for(resource)
  #   super(resource)
  # end

  # The path used after sending reset password instructions
  # def after_sending_reset_password_instructions_path_for(resource_name)
  #   super(resource_name)
  # end
end

app/controllers/users/registrations_controller.rb
class Users::RegistrationsController < Devise::RegistrationsController
  # before_action :configure_sign_up_params, only: [:create]
  # before_action :configure_account_update_params, only: [:update]

  # GET /resource/sign_up
  # def new
  #   super
  # end

  # POST /resource
  # def create
  #   super
  # end

  # GET /resource/edit
  # def edit
  #   super
  # end

  # PUT /resource
  # def update
  #   super
  # end

  # DELETE /resource
  # def destroy
  #   super
  # end

  # GET /resource/cancel
  # Forces the session data which is usually expired after sign
  # in to be expired now. This is useful if the user wants to
  # cancel oauth signing in/up in the middle of the process,
  # removing all OAuth session data.
  # def cancel
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_up_params
  #   devise_parameter_sanitizer.permit(:sign_up, keys: [:attribute])
  # end

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_account_update_params
  #   devise_parameter_sanitizer.permit(:account_update, keys: [:attribute])
  # end

  # The path used after sign up.
  # def after_sign_up_path_for(resource)
  #   super(resource)
  # end

  # The path used after sign up for inactive accounts.
  # def after_inactive_sign_up_path_for(resource)
  #   super(resource)
  # end
end

app/controllers/users/sessions_controller.rb
class Users::SessionsController < Devise::SessionsController
  # before_action :configure_sign_in_params, only: [:create]

  # GET /resource/sign_in
  # def new
  #   super
  # end

  # POST /resource/sign_in
  # def create
  #   super
  # end

  # DELETE /resource/sign_out
  # def destroy
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_in_params
  #   devise_parameter_sanitizer.permit(:sign_in, keys: [:attribute])
  # end
end

app/controllers/users/unlocks_controller.rb
class Users::UnlocksController < Devise::UnlocksController
  # GET /resource/unlock/new
  # def new
  #   super
  # end

  # POST /resource/unlock
  # def create
  #   super
  # end

  # GET /resource/unlock?unlock_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after sending unlock password instructions
  # def after_sending_unlock_instructions_path_for(resource)
  #   super(resource)
  # end

  # The path used after unlocking the resource
  # def after_unlock_path_for(resource)
  #   super(resource)
  # end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController

    before_action :authenticate_user!, if: :login

    def show
      @user = current_user
    end
    
    def edit
    end

    def update
      respond_to do |format|
        if @user.update(user_params)
          sign_in(@user == current_user ? @user : current_user, :bypass => true)
          format.html { redirect_to @user, notice: 'Your profile was successfully updated.' }
          format.json { head :no_content }
        else
          format.html { render action: 'edit' }
          format.json { render json: @user.errors, status: :unprocessable_entity }
        end
      end
    end
    
    def scores
      @user = current_user
      @scores = Score.where('user_id' => @user.id).find_each
    end
    
    def download_score
      @score = Score.find(params[:id])
      if @score
        send_file(@score.attachment.path, type: 'application/octet-stream', disposition: 'attachment')
      end
    end
    
    def finish_signup
      @user = current_user
      if request.patch? && params[:user] && params[:user][:email]
        if @user.update(user_params)
          # @user.skip_reconfirmation!
          sign_in(@user, :bypass => true)
          redirect_to @user, notice: 'Your profile was successfully updated.'
        else
          @show_errors = true
        end
      end
    end
    
    def destroy
      @user.destroy
      respond_to do |format|
        format.html { redirect_to root_url }
        format.json { head :no_content }
      end
    end
    
    private
    
    def set_user
      @user = User.find(params[:id])
    end
    
    def user_params
      accessible = [ :name, :email, :first_name ]
      accessible << [ :password, :password_confirmation ] unless params[:user][:password].blank?
      params.require(:user).permit(accessible)
    end
    
    def login
      warden = env['warden']
        !(warden.authenticated?(:admin))
    end
   
end

app/views/users/_login_modal.html.erb
<!DOCTYPE html>
<html>
<head>
<style>
.modal-header {
    padding: 2px 16px;
    background-color: #5cb85c;
    color: white;
}
</style>

</head>

<body>
    
<div class="modal fade in" tabindex="-1" role="dialog" id="login">
 
 <div class="modal-dialog">
        <div class="modal-header">
            
          <div class="container-fluid">
            <div class="row">
              <div class="col-md-12"><h2 class="modal-title">Log in</h2></div>
            </div>
          </div>
          
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>

        </div>

        <div class="modal-body">
        <%= form_for(resource, :as => resource_name, :url => session_path(resource_name)) do |f| %>

            <div>
                <%= f.label :email %><br/>
                <%= f.email_field :email, :autofocus => true %>
            </div>

            <div>
                <%= f.label :password %><br/>
                <%= f.password_field :password %>
            </div>

            <% if devise_mapping.rememberable? -%>
                <div>
                    <%= f.check_box :remember_me %>
                    <%= f.label :remember_me %>
                </div>
            <% end -%>

            <%= f.submit "Sign in", :class => 'btn btn-small btn-success' %>
        <% end %>

        </div>

        <div class="modal-footer">
            <div class="container">
                <div class="row">
                    <div class="col"><%= render "devise/shared/links" %></div>
                </div>
            </div>
        </div>
    </div>
</div>

</body>
</html>

app/views/users/_sign_up_modal.html.erb
<!DOCTYPE html>
<html>
<head>
<style>
.modal-header {
    padding: 2px 16px;
    background-color: #5cb85c;
    color: white;
}
</style>
 
</head>

<body>
    
<div class="modal fade in" tabindex="-1" role="dialog" id="sign_up">
 
   <div class="modal-dialog">
        <div class="modal-header">
            
          <div class="container-fluid">
            <div class="row">
              <div class="col-md-12"><h2 class="modal-title">Sign Up</h2></div>
            </div>
          </div>
          
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>

        </div>

        <div class="modal-body">
        <%= form_for(resource, :as => resource_name, :url => user_registration_path) do |f| %>

            <%= devise_error_messages! %>

            <div>
                <%= f.label :email %><br/>
                <%= f.email_field :email, :autofocus => true %>
            </div>
            <div>
                <%= f.label :first_name, 'Nickname' %><br/>
                <%= f.text_field :first_name, value: "Guest" %>
            </div>
            <div>
                <%= f.label :password %><br/>
                <%= f.password_field :password %>
            </div>

            <div>
                <%= f.label :password_confirmation %><br/>
                <%= f.password_field :password_confirmation %>
            </div>

        </div>

        <div class="modal-footer">
          <p><div>
            <%= f.submit "Sign up", :class => 'btn btn-small btn-success' %>
          </div></p>

          <p><a href="#" class="btn btn-small" data-dismiss="modal">Close</a></p>

        </div>
        <% end %>
        
    </div>
</div>

</body>
</html>

app/views/users/finish_signup.html.erb
<div id="add-email" class="container">
  <h1>Add Email</h1>
  <%= form_for(current_user, :as => 'user', :url => finish_signup_path(current_user), :html => { role: 'form'}) do |f| %>
    <% if @show_errors && current_user.errors.any? %>
      <div id="error_explanation">
        <% current_user.errors.full_messages.each do |msg| %>
          <%= msg %><br>
        <% end %>
      </div>
    <% end %>
    <div class="form-group">
      <%= f.label :email %>
      <div class="controls">
        <%= f.text_field :email, :autofocus => true, :value => '', class: 'form-control input-lg', placeholder: 'Example: email@me.com' %>
        <p class="help-block">Please confirm your email address. No spam.</p>
      </div>
    </div>
    <div class="actions">
      <%= f.submit 'Continue', :class => 'btn btn-primary' %>
    </div>
  <% end %>
</div>

app/views/users/scores.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <title><%= current_user.first_name %>'s scores</title>
  </head>

  <body>
    <div class="container">
      <div class="jumbotron">
         <h1><%= @user.first_name %>'s scores - <%= link_to "Upload score!", "#new", "data-toggle" => "modal", :class => 'btn btn-lg btn-success' %></h1>
         
         <div class="row">
            <div class="col-2"><h3>Score name</h3></div>
            <div class="col-2"><h3>Analyse?</h3></div>
            <div class="col-2"><h3>Privacy</h3></div>
            <div class="col-2"><h3>Share?</h3></div>
            <div class="col-2"><h3>Download</h3></div>
            <div class="col-2"><h3>Remove</h3></div>
        </div>
        
        <% @scores.each do |score| %>
            <div class="row">
                <div class="col-2"><%= score.name %></div>
                <div class="col-2"><%= link_to "Analyse", convert_score_path(score), :method => :put, remote: true %></div>
                <div class="col-2"><%= score.share ? "Public" : "Private" %></div>
                <div class="col-2">
                    <% if score.copied %>
                        Cannot share copies
                    <% end %>
                    <% if score.share && !score.copied %>
                        <span class="unshare-score"><%= link_to "Make private", unshare_score_path(score), :method => :put, remote: true %></span>
                    <% elsif !score.copied %>
                        <span class="share-score"><%= link_to "Make public", share_score_path(score), :method => :put, remote: true %></span>
                    <% end %>
                </div>
                <div class="col-2"><span class="download-score"><%= link_to "Download", download_score_user_path(score), target: :_blank, :method => :get %></span></div>
                <div class="col-2"><%= link_to 'Delete', score_path(score), data: {:confirm => 'Are you sure?'}, :method => :delete %></div>
            </div>
        <% end %>
        
      </div>

    </div><!-- /.container -->
  </body>
</html>

app/views/users/show.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <title><%= current_user.first_name %>'s profile</title>
  </head>

  <body>
    <div class="container">
      <div class="jumbotron">
          <h1>Hello, <%= current_user.first_name %> </h1>
          <p>Welcome to your home page. Click the button below to upload a new score, add it to your collection, and analyse it!</p>
          <p><%= link_to "Upload score!", "#new", "data-toggle" => "modal", :class => 'btn btn-success btn-lg' %></p>
      </div>
    </div>

    <div class="container">
      <!-- Example row of columns -->
      <div class="row">
        <div class="col-md-4">
          <h2>My scores</h2>
          <p>Manage your scores. View them, analyse them, share them, delete them.</p>
          <%= link_to "Click here!", users_scores_path, :class => 'btn btn-secondary' %>
        </div>
        <div class="col-md-4">
          <h2>Edit my profile</h2>
          <p>Manage your profile, change your information, delete your profile.</p>
          <%= link_to "Click here!", edit_user_path, :class => 'btn btn-secondary' %>
       </div>
        <div class="col-md-4">
          <h2>View public scores</h2>
          <p>Take a look at all the scores that have been shared with the public.</p>
          <%= link_to "Click here!", scores_path, :class => 'btn btn-secondary' %>
        </div>
      </div>

      <hr>

      <footer>
        <p>&copy; Company 2017</p>
      </footer>
    </div> <!-- /container -->
  </body>
</html>